SystemOrganization addCategory: #'GMF-Generator'!
SystemOrganization addCategory: #'GMF-Generator-Tests'!

TestCase subclass: #TestCodeGenerator
	instanceVariableNames: 'gAll rightClasses package pacakge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator-Tests'!

!TestCodeGenerator methodsFor: 'initialize-release' stamp: 'RostislavNovak 7/24/2013 15:54'!
setUp
| vLive mIsLive cBeing vBirthNumber vName vDateOfBirth vAnimals mAge cPerson cMan cWoman mEat mSound cAnimal cDog vHusban vWife aOneToOne cChild vChildrens vMother aOnteToMany vBoyFriend vGirlFriend aManyToMany association var |
vLive := GeneratedEOCVariable newName: 'live'.
mIsLive := GeneratedEOCMethod  newName: 'isLive'.
cBeing := GeneratedClass newName:  'Being'.
cBeing addVariable: vLive.
cBeing addMethod: mIsLive.

vBirthNumber := GeneratedEOCVariable newName: 'birthNumber'.
vName := GeneratedEOCVariable newName: 'name'.
vDateOfBirth := GeneratedEOCVariable newName: 'dateOfBirth'.
vAnimals := GeneratedEOCVariable newName: 'animal'.
vAnimals collection: 'OrderedCollection'.
mAge := GeneratedEOCMethod  newName: 'age'.
cPerson := GeneratedClass newName: 'Person'.
cPerson parent: cBeing.
cPerson addVariable: vBirthNumber.
cPerson addVariable: vName.
cPerson addVariable: vDateOfBirth.
cPerson addMethod: mAge.

cMan := GeneratedClass newName: 'Man'.
cMan parent: cPerson.
cWoman := GeneratedClass newName: 'Woman'.
cWoman parent: cPerson.

mEat := GeneratedEOCMethod newName: 'eat' Abstract: true.
mEat addArgument: (GeneratedEOCVariable newName: 'food').
mSound := GeneratedEOCMethod newName: 'sound' Instance: false Abstract: true.
cAnimal := GeneratedClass newName: 'Animal'.
cAnimal addMethod: mEat.
cAnimal addMethod: mSound.
cAnimal parent: cBeing.

mEat := GeneratedEOCMethod newName: 'eat'.
mEat addArgument: (GeneratedEOCVariable newName: 'food').
mSound := GeneratedEOCMethod newName: 'sound' Instance: false.
cDog := GeneratedClass newName: 'Dog'.
cDog addMethod: mEat.
cDog addMethod: mSound.
cDog parent: cAnimal.

vHusban := GeneratedEOCVariable newName: 'husban'.
vWife:= GeneratedEOCVariable newName: 'wife'.
cMan addVariable: vWife.
cWoman addVariable: vHusban.
aOneToOne := GeneratedAssociation newLeft: cMan Var: vWife RIght: cWoman Var: vHusban.
cMan association: aOneToOne.
cWoman association: aOneToOne.

cChild := GeneratedClass newName: 'Child'.
cChild parent: cPerson.
vChildrens := GeneratedEOCVariable newName: 'childrens'.
vChildrens collection: 'OrderedCollection'.
vMother:= GeneratedEOCVariable newName: 'mother'.
cWoman addVariable: vChildrens.
cChild addVariable: vMother.
aOnteToMany := GeneratedAssociation  newLeft: cWoman Var: vChildrens RIght: cChild Var: vMother.
cWoman association: aOnteToMany.
cChild association: aOnteToMany.
var := GeneratedEOCVariable newName: 'has'.
cPerson addVariable: vAnimals.
cAnimal addVariable: var.
association := GeneratedAssociation newLeft: cPerson Var: vAnimals RIght: cAnimal Var: var.
cPerson association: association.
cAnimal association: association.
vBoyFriend := GeneratedEOCVariable newName: 'boyFriends'.
vBoyFriend collection: 'OrderedCollection'.
vGirlFriend := GeneratedEOCVariable newName: 'girlFriends'.
vGirlFriend collection: 'OrderedCollection'.
cMan addVariable: vGirlFriend.
cWoman addVariable: vBoyFriend.
aManyToMany := GeneratedAssociation  newLeft: cMan Var: vGirlFriend RIght: cWoman Var: vBoyFriend.
cMan association: aManyToMany.
cWoman association: aManyToMany.

gAll := GeneratedAll new.
gAll addClass: cDog.
gAll addClass: cWoman.
gAll addClass: cMan.
gAll addClass: cAnimal.
gAll addClass: cPerson.
gAll addClass: cBeing.
gAll addClass: cChild.

rightClasses := SortedCollection new.
rightClasses add: 'Animal';  add: 'Being' ; add: 'Child'; add: 'Dog'; add: 'Man'; add:'Person'; add: 'Woman'.
package := PackageInfo new.
package packageName: 'generatedClasses'.! !

Object subclass: #AbstractGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!AbstractGenerator class methodsFor: 'accessing' stamp: 'RostsilavNovk 7/23/2013 23:21'!
generate: xObject
	^self subclassResponsibility.! !

AbstractGenerator subclass: #ClassGenerator
	instanceVariableNames: ''
	classVariableNames: 'class classVariables instVariables parent'
	poolDictionaries: ''
	category: 'GMF-Generator'!

!ClassGenerator class methodsFor: 'private' stamp: 'RostislavNovak 7/24/2013 15:39'!
addAssociations
	class association
		do: [ :a | 
			(a isLeft: class)
				ifTrue: [ class addVariable: a leftVar ]
				ifFalse: [ class addVariable: a rightVar ] ]! !

!ClassGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 00:12'!
createClass
	self class evaluatorClass evaluate: parent , ' subclass: #' , class name,'
		instanceVariableNames: ''' , instVariables,'''
		classVariableNames: ''' , classVariables,'''
		poolDictionaries: ''''
		category: ''generatedClasses'''.! !

!ClassGenerator class methodsFor: 'accessing' stamp: 'RostsilavNovk 7/24/2013 12:09'!
generate: xObject
	class := xObject.
	self setUpVariables.
	self setUpParent.
	self createClass.
	MethodGenerator generate: xObject.! !

!ClassGenerator class methodsFor: 'private' stamp: 'RostislavNovak 1/5/2014 20:01'!
getStringVariables: xCollection
	| str |
	str := ''.
	xCollection do: [ :v | str := str, ' ' , v name ].
	^ str! !

!ClassGenerator class methodsFor: 'private' stamp: 'RostislavNovak 1/5/2014 19:34'!
setUpParent
	parent := class parent isNil
		ifTrue: [ 'Object' ]
		ifFalse: [ class parent name ]! !

!ClassGenerator class methodsFor: 'private' stamp: 'RostislavNovak 7/24/2013 15:42'!
setUpVariables
	| instVars classVars |
	instVars := OrderedCollection new.
	classVars := OrderedCollection new.
	"self addAssociations."
	class variables
		do: [ :v | 
			v isInstance
				ifTrue: [ instVars add: v ]
				ifFalse: [ classVars add: v ] ].
	instVariables := self getStringVariables: instVars.
	classVariables := self getStringVariables: classVars! !

AbstractGenerator subclass: #MethodGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!MethodGenerator class methodsFor: 'private' stamp: 'volosmat 4/16/2014 23:21'!
createConstructor: xMethod
	| arguments |
	arguments := ''.
	
	xMethod arguments do: [ :each | arguments := (arguments, (Transform replaceCapitalLetter: each name),': x', each name,';
		') ].
	
	xMethod isConstructor
		ifTrue: [ ^ '
		^ super new initialize; 
            ',arguments,'
		yourself '' classified: ''instance creation'' '. ];
		ifFalse: [ ^ ' '' ' ]
	! !

!MethodGenerator class methodsFor: 'private' stamp: 'volosmat 4/16/2014 23:20'!
createMethod: xMethod Class: xClass
	| arguments isClass |
	
	arguments := self readMethodArguments: xMethod.
	isClass := ' '.
	xMethod isInstance
		ifFalse: [ isClass := ' class ' ].
	self class evaluatorClass
		evaluate:
			'' , xClass name , isClass , 'compile: ''' , xMethod name , arguments,
			(xMethod isAbstract
						ifTrue: [ '
			^ self subclassResponsibility '' ' ]
						ifFalse: [ self createConstructor: xMethod ]).
						! !

!MethodGenerator class methodsFor: 'private' stamp: 'volosmat 4/23/2014 20:09'!
createNew: xClass
	| stringToEvaluate |
	 
	xClass defaultConstructor 
		ifTrue: [ stringToEvaluate := '
	^ super new
		initialize;
		yourself' ];
		ifFalse: [ stringToEvaluate := '
	^ self shouldNotImplement' ].
	
	self class evaluatorClass evaluate:  '', xClass name, ' class compile: ''new ',stringToEvaluate,' '' classified: ''instance creation'' '! !

!MethodGenerator class methodsFor: 'accessing' stamp: 'volosmat 4/15/2014 10:36'!
generate: xObject
	"Create methods."

	xObject methods do: [ :m | self createMethod: m Class: xObject ].
	"Create additional methods."
	self createNew: xObject.
	VariableGenerator generate: xObject.! !

!MethodGenerator class methodsFor: 'private' stamp: 'RostislavNovak 1/5/2014 19:54'!
readMethodArguments: xMethod
	| arguments returnString |
	arguments := xMethod arguments.
	arguments isEmpty ifTrue: [^'' ].
	returnString := ': x' , (arguments first) name , ' '.
	arguments remove: (arguments first).
	returnString := returnString , (arguments inject: '' into: [ :str :a | str , a name , ': x' , a name , ' ' ]).
	^ returnString! !

AbstractGenerator subclass: #VariableGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

VariableGenerator class
	instanceVariableNames: 'varShakingGenerated'!

VariableGenerator class
	instanceVariableNames: 'varShakingGenerated'!

!VariableGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 12:47'!
createCollections: xClass
	| vars |
	vars := xClass variables select:[:v | v collection notNil ].
	^(vars inject: '' into: [:str :v | str, v name, ':=', v collection, ' new', '.
		' ])! !

!VariableGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/23/2013 21:01'!
createDefaultValues
	^''.! !

!VariableGenerator class methodsFor: 'private' stamp: 'volosmat 4/23/2014 20:33'!
createEssentialSetter: xVar inverseVar: xInverseVar
	^ '
	',xVar name,' isNil & xValue notNil
		ifTrue: [',xVar name,' := xValue.
			',xVar name, ' ', xInverseVar name,': self]'''! !

!VariableGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 12:47'!
createInitialize: xClass
	self class evaluatorClass evaluate: '' , xClass name , ' compile: ''initialize ', '
	', (self createCollections: xClass), ' 
	', self createDefaultValues, '
	', (self createNulls: xClass) , '
	 '' classified: ''initialize-release'' '.! !

!VariableGenerator class methodsFor: 'private' stamp: 'volosmat 4/23/2014 20:51'!
createInseparableSetter: xVar inverseVar: xInverseVar class: xClass
	| stringForEvaluate |
	
	stringForEvaluate :=  '
	',xVar name,' isNil & xValue notNil
		ifTrue: [',xVar name,' := xValue.
			composited := false.
			',xVar name, ' ', xInverseVar name,': self.
			composited := true ]'''.
		
	[ xClass variables detect: [ :each | each name = 'composited' ] ]
		on: Error 
		do: [ stringForEvaluate :=  '
	',xVar name,' isNil & xValue notNil
		ifTrue: [
			xValue composited
				ifFalse: [ 
					',xVar name,' := xValue.
					',xVar name, ' ', xInverseVar name,': self ]]''' ].
		
	^ stringForEvaluate! !

!VariableGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 12:38'!
createNulls: xClass
	| vars |
	vars := xClass variables select:[:v | v collection isNil ].
	^(vars inject: '' into: [:str :v | str, v name, ':= nil.
		' ])! !

!VariableGenerator class methodsFor: 'private' stamp: 'volosmat 4/12/2014 16:56'!
createSettersGetters: xClass
	xClass variables
		do: [ :v | 
			self class evaluatorClass evaluate: '' , xClass name , ' compile: ''' , v name , '
			^' , v name , ' '' classified: ''accessing'' '.
			self class evaluatorClass evaluate: '' , xClass name , ' compile: ''' , v name ,': xVal
			' , v name , ':= xVal'' classified: ''accessing'' ' ]! !

!VariableGenerator class methodsFor: 'private' stamp: 'volosmat 4/23/2014 20:38'!
createVarShaking: xClass
	| thatClass thatVar thisVar stringForEvaluate |
	xClass association
		do: [ :as | 
			as left == xClass
				ifTrue: [ 
					thatClass := as right.
					thatVar := as rightVar.
					thisVar := as leftVar ]
				ifFalse: [ 
					thatClass := as left.
					thatVar := as leftVar.
					thisVar := as rightVar ].
				
			[varShakingGenerated at: thisVar name. 
			varShakingGenerated at: thisVar name put: ( (varShakingGenerated at: thisVar name), ' | (xValue class == ' ,thatClass name,') ' )]
				on: Error 
				do: [ varShakingGenerated at: thisVar name put: '(xValue class == ' ,thatClass name,')' ] .
			
			thisVar collection == nil
				ifTrue: [ stringForEvaluate := '
			' , thisVar name , ' == xValue
				ifFalse: [
					' , (varShakingGenerated at: thisVar name),'
						ifTrue: [ 
							' , thisVar name,' := xValue.
							' , thisVar name , ' ' , thatVar name , ': self ] ] '' classified: ''accessing'' ' ]
				ifFalse: [ stringForEvaluate :=  '
			(' , thisVar name , ' anySatisfy: [ :v | v == xValue ] )
				ifFalse: [
					' , (varShakingGenerated at: thisVar name),'
					ifTrue: [ 
						' , thisVar name,' add: xValue.
						xValue ' , thatVar name , ': self ] ] '' classified: ''accessing'' ' ].
			"new setter when relation is essential componentOf"
			(as isEssential)
				ifTrue: [ stringForEvaluate := self createEssentialSetter: thisVar inverseVar: thatVar].
			"new setter when relation is inseparable componentOf"
			(as isInseparable)
				ifTrue: [ stringForEvaluate := self createInseparableSetter: thisVar inverseVar: thatVar class: xClass].
			self class evaluatorClass evaluate: ('' , xClass name , ' compile: ''', thisVar name, ': xValue'), stringForEvaluate  
			]! !

!VariableGenerator class methodsFor: 'accessing' stamp: 'volosmat 4/12/2014 21:32'!
generate: xObject
	varShakingGenerated := KeyedTree new.
	self createSettersGetters: xObject.
	self createInitialize: xObject.
	self createVarShaking: xObject.! !

Object subclass: #CodeGenerator
	instanceVariableNames: ''
	classVariableNames: 'data'
	poolDictionaries: ''
	category: 'GMF-Generator'!

!CodeGenerator class methodsFor: 'accessing' stamp: 'RostsilavNovk 7/24/2013 12:09'!
generateCode: interface
	self readData: interface.
	[ data classes notEmpty ] whileTrue: [ self readNextClass ]! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 4/5/2013 14:16'!
readData: interface  
	data:= interface asGeneratorData.! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovak 1/5/2014 19:59'!
readNextClass
	| class |
	"Take first not generated."
	class := data classes first.
	self readSelectedClass: class.! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 11:49'!
readSelectedClass: xClass
	"If it has parent and it is not generated."
	xClass parent isNil
		ifFalse: [self readSelectedClass: xClass parent].
	"Generate class."
	ClassGenerator generate: xClass.
	data removeClass: xClass.! !

!CodeGenerator class methodsFor: 'testing' stamp: 'RostsilavNovk 7/24/2013 12:09'!
setDataWithAll: xData
	data := xData.
	[ data classes notEmpty ] whileTrue: [ self readNextClass ]! !

Object subclass: #GeneratedAll
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedAll class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 10:32'!
new
	^ super new
		initialize;
		yourself! !

!GeneratedAll methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 10:31'!
addClass: aGeneratedClass
	"adding classes"

	classes add: aGeneratedClass.! !

!GeneratedAll methodsFor: 'accessing' stamp: 'RostsilavNovk 7/24/2013 00:54'!
classes
	^ classes copy.! !

!GeneratedAll methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 10:25'!
initialize
	"set numbers of used classes and relations to empty"

	classes := OrderedCollection new.
	^ self! !

!GeneratedAll methodsFor: 'accessing' stamp: 'RostsilavNovk 7/24/2013 00:46'!
removeClass: aGeneratedClass
	"remove  classes"

	classes :=  classes reject:[: c| c == aGeneratedClass ].! !

Object subclass: #GeneratedAssociation
	instanceVariableNames: 'left leftVar right rightVar essential inseparable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedAssociation class methodsFor: 'instance creation' stamp: 'RostislavNovk 5/19/2013 20:54'!
newLeft: xLeft Var: xLVar RIght: xRight Var: xRVar
	^ super new
		left: xLeft;
		leftVar: xLVar;
		right: xRight;
		rightVar: xRVar;
		yourself! !

!GeneratedAssociation class methodsFor: 'instance creation' stamp: 'volosmat 4/24/2014 10:55'!
newLeft: xLeft Var: xLVar RIght: xRight Var: xRVar essential: xEssential inseparable: xInseparable
	^ super new
		left: 			xLeft;
		leftVar: 		xLVar;
		right: 			xRight;
		rightVar: 		xRVar;
		essential:		xEssential;
		inseparable: 	xInseparable;
		yourself! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'volosmat 4/15/2014 18:55'!
essential: xEssential
	essential := xEssential ! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'volosmat 4/23/2014 12:34'!
inseparable: xInseparable
	inseparable := xInseparable! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'volosmat 4/15/2014 18:56'!
isEssential
	^ essential ifNil: [ essential := false ]! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'volosmat 4/23/2014 12:35'!
isInseparable
	^ inseparable ifNil: [ inseparable := false ]! !

!GeneratedAssociation methodsFor: 'testing' stamp: 'RostsilavNovk 7/24/2013 13:01'!
isLeft: xClass
	^left == xClass! !

!GeneratedAssociation methodsFor: 'testing' stamp: 'RostsilavNovk 7/24/2013 13:01'!
isRight: xClass
	^right == xClass! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 20:50'!
left
 ^left! !

!GeneratedAssociation methodsFor: 'private' stamp: 'volosmat 4/24/2014 11:05'!
left: xLeft
	left := xLeft.
	xLeft association: self! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 20:51'!
leftVar
 ^leftVar! !

!GeneratedAssociation methodsFor: 'private' stamp: 'RostislavNovk 5/19/2013 20:50'!
leftVar: xLeft
	leftVar := xLeft! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 20:50'!
right
^right! !

!GeneratedAssociation methodsFor: 'private' stamp: 'volosmat 4/24/2014 11:05'!
right: xRight
	right := xRight.
	xRight association: self! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 20:51'!
rightVar
^rightVar! !

!GeneratedAssociation methodsFor: 'private' stamp: 'RostislavNovk 5/19/2013 20:50'!
rightVar: xRight
	rightVar := xRight! !

Object subclass: #GeneratedClass
	instanceVariableNames: 'name comment variables methods superClass generated association defaultConstructor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:43'!
newName: xName
	^ super new
		initialize;
		name: xName;
		yourself! !

!GeneratedClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:44'!
newName: xName Comment: xComment
	^ super new
		initialize;
		name: xName;
		comment: xComment;
		yourself! !

!GeneratedClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:44'!
newName: xName Comment: xComment Code: xCode
	^ super new
		initialize;
		name: xName;
		comment: xComment;
		code: xCode;
		yourself! !

!GeneratedClass class methodsFor: 'instance creation' stamp: 'volosmat 4/23/2014 20:05'!
newName: xName defaultConstructor: xDefaultConstructor
	^ super new
		initialize;
		name: xName;
		defaultConstructor: xDefaultConstructor;
		yourself! !

!GeneratedClass methodsFor: 'accessing' stamp: 'JiriMertin 4/1/2013 19:27'!
addMethod: aGeneratedEOCMethod
	"add to sortedcollection"

	methods add: aGeneratedEOCMethod! !

!GeneratedClass methodsFor: 'accessing' stamp: 'volosmat 4/12/2014 16:33'!
addVariable: aGeneratedEOCVariable
	"add to sortedcollection"
	[ variables detect: [ :each | each name = aGeneratedEOCVariable name ] ]
		on: Error
		do: [ variables add: aGeneratedEOCVariable ]! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 20:59'!
association
	^association copy.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 21:42'!
association: xAs
	association add: xAs.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
comment
	^comment.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:50'!
comment: xComment
	comment:= xComment.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'volosmat 4/23/2014 20:06'!
defaultConstructor
	^ defaultConstructor! !

!GeneratedClass methodsFor: 'accessing' stamp: 'volosmat 4/23/2014 20:06'!
defaultConstructor: anObject
	defaultConstructor := anObject! !

!GeneratedClass methodsFor: 'initialize-release' stamp: 'volosmat 4/23/2014 20:04'!
initialize
	variables			:= OrderedCollection new.
	methods			:= OrderedCollection new.
	association			:= OrderedCollection  new.
	comment			:=''.
	superClass			:=nil.
	generated 			:= false.
	defaultConstructor := true.
	! !

!GeneratedClass methodsFor: 'testing' stamp: 'RostislavNovk 4/8/2013 00:25'!
isGenerated
	^generated! !

!GeneratedClass methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 11:07'!
isSubClass
	[ superClass isNil ]
		ifTrue: [ ^ false ]
		ifFalse: [ ^ true ]! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
methods
	^methods copy.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
name
	^name.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:50'!
name: xName
	name:= xName.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
parent
	^superClass.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:50'!
parent: xGeneratedClass
	superClass:= xGeneratedClass .! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
variables
	^variables copy.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/8/2013 00:26'!
wasGenerated
	generated := true.! !

Object subclass: #GeneratedElementOfClass
	instanceVariableNames: 'name instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

GeneratedElementOfClass subclass: #GeneratedEOCMethod
	instanceVariableNames: 'code arguments abstract constructor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'volosmat 4/24/2014 10:35'!
newName: xName
	^ (super new initialize)
		name: 		xName;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'volosmat 4/24/2014 10:36'!
newName: xName Abstract: xAbstract
	^ (super new initialize)
		abstract: 		xAbstract;
		name: 		xName;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'volosmat 4/24/2014 10:36'!
newName: xName Instance: xInstance Abstract: xAbstract
	^ (super new initialize)
		abstract: 		xAbstract;
		name: 			xName;
		instance:		xInstance;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'volosmat 4/24/2014 10:36'!
newName: xName Instance: xInstance Abstract: xAbstract Constructor: xConstructor
	^ (super new initialize)
		abstract: 		xAbstract;
		constructor: 	xConstructor;
		name: 			xName;
		instance:		xInstance;
		yourself! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 18:56'!
abstract: xAbstract
	abstract := xAbstract.! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:28'!
addArgument: xGeneratedEOCVariable
	arguments add: xGeneratedEOCVariable! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:51'!
arguments
	^ arguments copy! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:51'!
code
	^ code! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:47'!
code: xCode 
	code := xCode.! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'volosmat 4/15/2014 09:17'!
constructor: anObject
	constructor := anObject! !

!GeneratedEOCMethod methodsFor: 'initialize-release' stamp: 'volosmat 4/16/2014 23:11'!
initialize
	super initialize.
	abstract := false.
	constructor  := false.
	arguments:= OrderedCollection new.! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 18:55'!
isAbstract
	^abstract! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'volosmat 4/15/2014 09:40'!
isConstructor
	^ constructor! !

GeneratedElementOfClass subclass: #GeneratedEOCVariable
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedEOCVariable methodsFor: 'accessing' stamp: 'RostislavNovk 5/10/2013 20:01'!
collection
	^collection! !

!GeneratedEOCVariable methodsFor: 'accessing' stamp: 'RostislavNovk 5/10/2013 20:01'!
collection: xCollection
	collection := xCollection! !

!GeneratedElementOfClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:46'!
newName: xName
	^ super new
		initialize;
		name: xName;
		yourself! !

!GeneratedElementOfClass class methodsFor: 'instance creation' stamp: 'volosmat 4/15/2014 10:46'!
newName: xName Instance: xInstance
	^ super new
		initialize;
		name: xName;
		instance: xInstance;
		yourself! !

!GeneratedElementOfClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 18:01'!
initialize
	instance := true
! !

!GeneratedElementOfClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:51'!
instance: xInstance
	instance:=xInstance.
! !

!GeneratedElementOfClass methodsFor: 'accessing' stamp: 'RostislavNovak 1/5/2014 19:39'!
isClass
	"returns opposite of isInstantce"

	^ instance not.! !

!GeneratedElementOfClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 17:59'!
isInstance
	^ instance! !

!GeneratedElementOfClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:52'!
name
	^ name! !

!GeneratedElementOfClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:51'!
name: xName
	name := xName.
! !
